﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.TreeView;

namespace TreeViewDndComplex
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            radTreeViewLeft.ExpandAll();
            radTreeViewRight.ExpandAll();
        }

        private void radTreeViewLeft_PreviewDragEnded(object sender, RadTreeViewDragEndedEventArgs e)
        {
            if (e.TargetDropItem == null)
            {
                MessageBox.Show("Target dropitem is null!");
            }
            else if(e.TargetDropItem.ParentTreeView == this.radTreeViewLeft)
            {
                MessageBox.Show("DND forbidden!");
            }
            e.Handled = true;
        }

        private void radTreeViewRight_PreviewDragEnded(object sender, RadTreeViewDragEndedEventArgs e)
        {
            if (e.TargetDropItem == null || e.TargetDropItem.ParentTreeView == this.radTreeViewLeft)
            {
                e.Handled = true;
                return;
            }
            else if ((e.DraggedItems[0] as RadTreeViewItem).ParentTreeView == this.radTreeViewRight)
            {            
              if(e.TargetDropItem.ParentItem != null)
              {
                  MessageBox.Show("Cannot drop on NON-Root level item or position!");
                  e.Handled = true;
              }
              if (e.TargetDropItem.ParentItem == null && e.DropPosition == DropPosition.Inside &&
                  e.TargetDropItem.DefaultImageSrc.ToString() == "file.png")
              {
                  MessageBox.Show("Cannot drop inside a file!");
                  e.Handled = true;
              }
            }
            else
            {
                foreach (object item in e.DraggedItems)
                {
                    RadTreeViewItem clonedItem = CopyItem(item as EditableHeaderedItemsControl);
                    switch (e.DropPosition)
                    {
                        case DropPosition.After:
                            if (e.TargetDropItem.ParentItem == null)
                            {
                                e.TargetDropItem.ParentTreeView.Items.Insert(e.TargetDropItem.Index + 1, clonedItem);
                            }
                            else 
                            {
                                MessageBox.Show("Cannot drop on NON-Root level item or position!");
                            }
                            break;
                        case DropPosition.Before:
                            if (e.TargetDropItem.ParentItem == null)
                            {
                                e.TargetDropItem.ParentTreeView.Items.Insert(e.TargetDropItem.Index, clonedItem);
                            }
                            else 
                            {
                                MessageBox.Show("Cannot drop on NON-Root level item or position!");
                            }
                            break;
                        case DropPosition.Inside:
                            if (e.TargetDropItem.ParentItem == null && e.TargetDropItem.DefaultImageSrc.ToString() == "folder.png")
                            {
                                e.TargetDropItem.Items.Add(clonedItem);
                            }
                            else 
                            {
                                if (e.TargetDropItem.DefaultImageSrc.ToString() == "file.png")
                                {
                                    MessageBox.Show("Cannot drop inside a file!");
                                }
                                else 
                                {
                                    if (e.TargetDropItem.ParentItem != null)
                                    {
                                        MessageBox.Show("Cannot drop on NON-Root level item or position!");
                                    }
                                }
                                    
                            }
                            break;
                    }
                }
                e.Handled = true;
            }
        }

        public RadTreeViewItem CopyItem(EditableHeaderedItemsControl item)
        {
            RadTreeViewItem newItem = new RadTreeViewItem();
            newItem.Header = item.Header;
            newItem.DefaultImageSrc = (item as RadTreeViewItem).DefaultImageSrc;
            return newItem;
        }
    }
}
